//+------------------------------------------------------------------+
//|                                               AlertSignal_v1.mq4 |
//|                                  Copyright  2009, WWW.FIBOOK.RU |
//|                                                 http://fibook.ru |
//+------------------------------------------------------------------+
#property copyright  "Copyright  2009, FIBOOK.RU"
#property link       "http://fibook.ru"
#define Str          "http://fibook.ru"
#define STRING_ID    "AlertSignal_"
#property indicator_chart_window
extern int     StartBar=1;                            // Start bar
extern string indicator = "Insert Indicator Name";    // Custom indicator
extern bool    VLine = true;                          // Vertical line output switch
extern bool    SignalAlert=false;                     // Alert window output switch
extern bool    SignalComment=true;                    // Comment output switch
extern bool    SignalPlay= false;                     // Sound play switch
extern string  Signal = "alert.wav";                  // Custom sound file
extern string  UserText = "direction changed";      // User comment
IndicatorShortName("AlertSignal_v1 ");
//+------------------------------------------------------------------+
//| AlertSignal_v1 indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| AlertSignal_v1 indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for (int i=0; i<8; i++)
      ObjectDelete(STRING_ID+"VL_"+i);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| AlertSignal_v1 indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
string text;
int            ExtBars=150; // Number of the last bars for calculation
double         First;       // Internal variable
double         Second;      // Internal variable
int            per;         // Internal variable
   if (indicator == "Insert Indicator Name") 
      {
         Alert (indicator);
         return;
      }
   if (per == Time[0]) return; // Adjust once in a period
         per = Time[0];
//----
      for (int ii=StartBar; ii<ExtBars; ii++)
         for (int i=0; i<8; i++)
         {
            First  = iCustom(NULL,0,indicator,i,ii);
            Second = iCustom(NULL,0,indicator,i,ii+1);
            if ((Second==0&&First>0)||(Second>0&&First==0))
            {
               text = StringConcatenate( Str+" - On ",ii+1," bar ",Symbol()," -  ",indicator," ");
               AlertComment (text+UserText);
               if (VLine == true)
               ObjectCreate(STRING_ID+"VL_"+i,0,0,Time[ii],Bid);
               return;
            }
         }   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| AlertSignal_v1 indicator Subfunction                             |
//+------------------------------------------------------------------+

void AlertComment (string text)
   {
      if (SignalAlert   == true)    Alert    (text);
      if (SignalComment == true)    Comment  (text);
      if (SignalPlay    == true)    PlaySound(Signal);
   }

